# SPDX-FileCopyrightText: Copyright (c) 2025 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
# SPDX-License-Identifier: Apache-2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from hydra.core.config_store import ConfigStore
from imaginaire.lazy_config import LazyCall as L
from cosmos_predict2.models.wan_warped_model import WanWarpedModel, WanWarpedConfig


WAN_PRETRAIN_MODEL = dict(
    trainer=dict(
        distributed_parallelism="fsdp",
    ),
    model=L(WanWarpedModel)(
        config=L(WanWarpedConfig)(
            dit_pretrain_path="Wan2.2/Wan2.2-TI2V-5B",
        )
    ),
)

WAN_PRETRAIN_MODEL_DDP = dict(
    trainer=dict(
        distributed_parallelism="ddp",
    ),
    model=L(WanWarpedModel)(
        config=L(WanWarpedConfig)(
            dit_pretrain_path="Wan2.2/Wan2.2-TI2V-5B",
            fsdp_shard_size=0,
        )
    ),
)


def register_model() -> None:
    cs = ConfigStore.instance()
    cs.store(
        group="model", package="_global_", name="wan_fsdp_5b", node=WAN_PRETRAIN_MODEL
    )
    cs.store(
        group="model", package="_global_", name="wan_ddp_5b", node=WAN_PRETRAIN_MODEL_DDP
    )